package As;

use MyUtils;
use Exporter;
@ISA=('Exporter');
@EXPORT=qw(&getExonBoundary &getKnownSpliceSites);


sub getKnownSpliceSites {
  my ($seq,$header) = @_;
  my @tv=split(/_/,$header);
  print "$header\n";
  my $strnd="";
  my $left;
  my $exons;
  my $rght;
  if( $tv[1] =~ /.*:([+-])/) {
    $strnd=$1;
    #print "$strnd\n";
  }
  if($header =~ /\[(.*)\],_\[(.*)\](_,|,_)\[(.*)\]/ ) {
    ($left,$exons,$rght)=($1,$2,$4);
  }

  my ($beg,$end) = getExonBoundary($header);
  #print "djust beg: $beg end: $end, $lmax $rmin, $stex[0] $stex[$#stex]\n";
  my %splice;
  #print "left:[$left] ex:[$exons] rght:[$rght]\n";
  my $relb=compRel($beg,$strnd,$beg,$end);
  my $rele=compRel($end,$strnd,$beg,$end);
  if( $relb > $rele ) {
    ($relb,$rele)=($rele,$relb);
  }
  #my @exLst;
  my %acnt;
  my $num_exons=0;
  my @schar = unpack("A1" x length($$seq),$$seq);
  while ( $exons =~ /(\d+)_(\d+)/g ) {
    my ($end5,$end3)=($1,$2);
    my $rel5=compRel($end5,$strnd,$beg,$end);
    my $rel3=compRel($end3,$strnd,$beg,$end);
    if ( $rel5 > $rel3 ) {
      ($rel5,$rel3) = ($rel3,$rel5);
    }
    my ($t5,$t3) = classType($relb,$rele,$rel5,$rel3,$strnd,$left,$rght,\@schar);
    my $exStr= "$rel5 $rel3 $t5 $t3";
    #print "known exon: $exStr\n";
    $splice{$rel5} = $t5;
    $splice{$rel3} = $t3;
    $acnt{$rel5}++;
    $acnt{$rel3}++;
    $num_exons++;
  }
  my ($max,$min)=(-1,-1);
  foreach my $spl (keys %splice) {
    if( $max==-1 || $max<$spl) {
      $max=$spl;
    }
    if( $min==-1 || $min>$spl) {
      $min=$spl;
    }
  }
  foreach my $spl (keys %splice) {
    my $event_type="";
    if ($tv[3] eq "MS" || $tv[3] eq "PT:MS") {
      $event_type="con";
      if( $acnt{$spl} < $num_exons ) {
	$event_type = "alt";
      }
    } elsif ($tv[3] eq "IR" || $tv[3] eq "PT:IR") {
      $event_type="con";
      if( $acnt{$spl} < $num_exons ) {
	if( $spl > $min && $spl < $max ) {
	  $event_type = "alt";
	}
      }
    } elsif ($tv[3] eq "SE" || $tv[3] ) {
      $event_type="alt";
    } else {
      #print "unhandeled case: $tv[3]\n";
      exit(1);
    }
    $splice{$spl} .= " $event_type";
    #print "store: [$spl $splice{$spl}]\n";
  }
  return \%splice;
}

sub classType {
  my ($beg,$end,$rel5,$rel3,$strnd,$left,$rght,$seqR) = @_;
  my @schar = @$seqR;
  my $lDebug=0;
  my ($t5,$t3)=("other","other");
  if ( ($strnd eq "-" && $left) || ($rel3 < ($end-6)) ||
       ($strnd eq "+" && $rght) 
     ) {
    my $str = "$schar[$rel3]$schar[$rel3+1]";
    print "don: $rel3 $str\n" if($lDebug);
    $t3="don"  if($str eq "GT" || $str eq "GC");
  }
  if( ($strnd eq "-" && $rght) || $rel5 > ($beg+23) ||
      ($strnd eq "+" && $left)
    ) {
    my $str = "$schar[$rel5-3]$schar[$rel5-2]";
    print "acc: $rel5 $str\n" if($lDebug);
    $t5="acc" if($str eq "AG");
  }
  return ($t5,$t3);
}

sub getExonBoundary {
  my ($pline,$donOff,$accOff) = @_;
  #print "pl: $pline\n";
  my @exons;
  my @all;
  while( $pline =~ /\[(.*?)\]/g ) {
    my $ae=$1;
    my $istr="";
    if( $ae ) {
      $istr=":";
      #print "hey: [$ae]\n";
      while ( $ae =~ /(\d+)_(\d+)/g ) {
	my ($left,$rght) = ($1,$2);
	if($left < 1 || $rght < 1 ) {
	  print "error [$left $rght]\n";
	  print "$line\n";
	  exit(1);
	}
	$istr = "$left " . $istr;
	$istr = $istr . " $rght";
      }
    }
    push(@exons,$istr);
    push (@all,$ae);
  }
  #print "bs: [@exons]\n";
  #return (-1,-1);
  my ($cmn,$cmx) = getMinMax($exons[1]);
  my ($lmn,$lmx) = ($cmn,$cmn);
  my ($rmn,$rmx) = ($cmx,$cmx);
  #print "@exons\n";
  if ( $exons[0] ) {
    ($lmn,$lmx) = getMinMax($exons[0]);
  }
  if ( $exons[2] ) {
    ($rmn,$rmx) = getMinMax($exons[2]);
  }
  my ($beg,$end) = ($lmx,$rmn);
  if( $beg > $end ) {
     print "probs here: $beg $exons[1] $end\n";
     print "$line\n";
     exit(1);
  }
  my $strnd="";
  if( $pline =~ /_.{0,2}:{0,1}([+-])_/ ) {
    $strnd=$1;
  }
  #print "strnd: $strnd\n";
  #exit(1);

  #my $ex=$pline;
  #print "es: $exons[1]\n";
  my @ec=split(/ /,$exons[1]);
  my $mnLeft=-1;
  my $mxRght=-1;
  my $type="left";
  my ($relBeg,$relEnd,$relLeft,$relRght);
  $relEnd=compRel($end,$strnd,$beg,$end);
  $relBeg=compRel($beg,$strnd,$beg,$end);
  for(my $iter=0; $iter <= $#ec; $iter++) {
    if( $ec[$iter] eq ":" ) {
      $type="rght";
    } elsif ($type eq "left" && ($ec[$iter] < $mnLeft || $mnLeft == -1)) {
      $mnLeft=$ec[$iter];
      $relLeft=compRel($mnLeft,$strnd,$beg,$end);
    } elsif ($type eq "rght" && ($ec[$iter] > $mxRght || $mxRght == -1)) {
      $mxRght=$ec[$iter];
      $relRght=compRel($mxRght,$strnd,$beg,$end);
    }
  }
  #print "reg: $strnd $beg $end\n";
  #print upstream intron
  # WARNING IF donOff and accOff
  # have differen't values then you need to swap on
  # negative strand
  if( !$donOff ) {
    $donOff=400;
  } 
  if( !$accOff ) {
    $accOff=400;
  }
  my ($left,$rght)=(-1,-1);
  #print "beg: $beg, end: $end, $relEnd $relBeg, $mnLeft $mxRght\n";
  if( ($mnLeft-$accOff) > $beg ) {
    #print "here? crap $mnLeft\n";
    $left=$mnLeft-$accOff;
  } else {
    $left = $beg;
  }
  if( $mxRght+$donOff < $end ) {
    $rght = $mxRght+$donOff;
  } else {
    $rght = $end;
  }
  #print "$beg $end\n";
  #print "$mnLeft $mxRght\n";
  #print "$left $rght\n";
  if( $mnLeft==-1 || $mxRght==-1 ) {
    exit(1);
  }
  #print "res: [$left,$rght]\n";
  return ($left,$rght);
}


sub getMinMax {
  my ($set) = @_;
  my @tal = split(/ /,$set);
  my ($min,$max) = (-1,-1);
  for(my $iter=0; $iter <= $#tal; $iter++) {
    if( $tal[$iter] =~ /(\d+)/ ) {
      my $val = $1;
      if( $min == -1 ) {
	$min = $val;;
      } elsif( $val < $min) {
	$min = $val;
      }
      if( $max == -1 ) {
	$max = $val;;
      } elsif( $val > $max) {
	$max = $val;
      }
    }
  }
  return ($min,$max);
}
