#ifndef _MODEL_H
#define _MODEL_H

#include <vector>
#include <string>
#include <ostream>

class Model {
 public:
  virtual ~Model() { }

  virtual void gnuPlot(std::ostream&) const = 0;

  virtual const Model&
    getModel(unsigned pos) const = 0;
  
  virtual void 
  update(const std::string&,int,int) = 0;

  virtual double 
  getLogProb(const std::string&,int,int) const = 0;

  virtual void
    normalize() = 0;

  virtual void
    read(std::istream&) = 0;

  virtual void
    write(std::ostream&) const = 0;

  virtual unsigned
    getWidth() const = 0;

  virtual int
    getOrder() const = 0;
  
  virtual std::ostream&
    print(std::ostream&) const = 0;

  virtual Model* operator-(const Model&) const = 0;
  virtual Model& operator=(const Model&) = 0;
  virtual void operator-=(const Model&) = 0;
  virtual void operator*=(double) = 0;
  virtual void operator*=(const Model&) = 0;
  virtual void operator/=(int) = 0;
  virtual void operator+=(const Model&) = 0;
  virtual void add(double) = 0;
  virtual Model* clone() const = 0;
  virtual double
     getVal(const std::string&, int, unsigned=0) const = 0;

};

#endif // _MODEL_H

