#include "Kmer.h"
#include "cidx.h"
#include <list>
#include <stdlib.h>
#include <fstream>
#include <iomanip>
#include <sstream>
#include <cmath>
#include <iostream>

extern bool GLOBAL_DEBUG1;

using namespace std;

Kmer::Kmer(int chain_len, double val, int output_size) : MarkovChain(chain_len,val,output_size) { }

Kmer::Kmer(const Kmer& mc) : MarkovChain(mc) { }

Model*
Kmer::clone() const {
  return new Kmer(*this);
}

void
Kmer::normalize() {
  unsigned output_size = _counter.size();
  assert(output_size>0);
  double tot = 0;
  for(unsigned kmer = 0; kmer < _counter[0].size(); ++kmer) {
    for(unsigned base = 0; base < output_size; ++base) {
      tot += _counter[base][kmer];
    }
  }
  if(tot>0) {
  for(unsigned kmer = 0; kmer < _counter[0].size(); ++kmer) {
      //double dsum = 0;
      for(unsigned base = 0; base < output_size; ++base) {
	_counter[base][kmer] /= tot;
	assert( _counter[base][kmer] <= 1);
	assert( _counter[base][kmer] >= 0);
	//dsum += _counter[base][kmer];
      }
    }
  }
}
