#ifndef _ANNOTATION_INFO_H
#define _ANNOTATION_INFO_H

#include "GeneList.h"
#include <ext/hash_map>
#include <iostream>
#include <assert.h>


class AnnotationInfo {
 public:
  struct myhash
  { size_t operator()(const std::string& __s) const { 
    return __gnu_cxx::__stl_hash_string(__s.c_str()); } };
  typedef __gnu_cxx::hash_map<std::string,std::list<GffFeature*>, myhash > CodeHashT;
  typedef __gnu_cxx::hash_map<std::string,std::list<GeneList*> , myhash> GeneHashT;
  const CodeHashT& getCodeHash() const { return _codeh; }
  const GeneHashT& getGeneHash() const { return _geneh; }
 public:
  void load(const std::string&); //, const hmap_str_t&);

  static std::list<GeneList*>::const_iterator
    findGeneList(const std::list<GeneList*>&, const std::string&);
  static std::list<GeneList*>::iterator
    findGeneList(std::list<GeneList*>&, const std::string&);

  static void createInstance(const std::string& file) {
    assert(!AnnotationInfo::_instance); 
    AnnotationInfo::_instance = new AnnotationInfo;
    AnnotationInfo::_instance->load(file);
  }
  static const AnnotationInfo*
  getInstance() {
    return AnnotationInfo::_instance;
  }

 private:
  static AnnotationInfo* _instance;
  CodeHashT _codeh;
  GeneHashT _geneh;
};

#endif // _ANNOTATION_INFO_H
