#ifndef _BAUMWELCH_H
#define _BAUMWELCH_H

#include "RateHmm.h"
#include "PhyloModel.h"
#include "MultiModel.h"
#include <vector>
#include <string>

class BaumWelch {
 public: 
  BaumWelch(RateHmm&, PhyloModel&, MultiModel&);
  ~BaumWelch();

  void 		
    train(const std::vector<std::string*>&, unsigned, unsigned, int, int);
  double getLastProb() const;

  //double
    //getModelProb(const std::vector<std::string*>&, unsigned, unsigned, int );

 private:
  void 		
    Estimate(const std::vector<std::string*>&, unsigned, unsigned, int,bool);
  void 		
    Backward(const std::vector<std::string*>&, unsigned, unsigned, int, const std::vector<double>&,bool);

  double
    Forward(const std::vector<std::string*>&, unsigned, unsigned, int, std::vector<double>&,bool);
	
 private:
  RateHmm& _hmm;
  PhyloModel& _phyloModel;
  MultiModel& _nucDistr;
  std::vector<std::vector<double> > _alpha;
  std::vector<std::vector<double> > _beta;
  double _prob;
}; // _BAUMWELCH_H

#endif
