#ifndef _CONSHMM_H
#define _CONSHMM_H

#include <ostream>
#include <string>
#include <vector>

class ConsHmm {
 public:
  ConsHmm(int);
  ConsHmm(int,const std::vector<double>&, const std::vector<std::vector<double> >&);
  ConsHmm(const ConsHmm&);
  
  void operator+=(const ConsHmm&);
  void operator/=(int);

  double getProb(int) const;
  double getProb(int,int) const;
  void update(int);
  void update(int,int);
  void print(std::ostream&) const;
  void write(std::ostream&) const;
  void read(std::istream&);
  void normalize();


 private:
  std::vector<double> _init;
  std::vector<std::vector<double> > _trans;
};
#endif //_CONSHMM_H
