#ifndef _CONSTHRESH_H
#define _CONSTHRESH_H

#include <vector>
#include <list>
#include "utils.h"
#include "ModelType.h"

class ConsThresh{
 public:
  typedef ModelType::cname_t cname_t;


 public:
  ConsThresh();
  void addNuc(cname_t distr, double val) { assert(distr<ModelType::eCnameEnd);_sdistrNuc[distr].push_back(val); }
  dpair_t getConsThreshNuc(cname_t distr) { return _threshNuc[distr]; }
  void add(cname_t distr, double val) { assert(distr<ModelType::eCnameEnd);_sdistr[distr].push_back(val); }
  dpair_t getConsThresh(cname_t distr) { return _thresh[distr]; }
  void write(const std::string&) const;
  void read(const std::string&);
  void
    makeThresholds();

  dpair_t getRange(cname_t) const;

 private:
  enum consv_t {
    eIntronDn = 0, eIntronUp, eExonPrc, eExonNpc, eAcc, eDon, eConsvEnd
  };
  static consv_t cname2consv(cname_t);
  static void
    makeThresholdsHelp(std::vector<dpair_t>&, std::vector<std::list<double> >&, std::vector<dpair_t>&);
  
 private:
  std::vector<std::list<double> > _sdistr;
  std::vector<dpair_t> _thresh;
  std::vector<std::list<double> > _sdistrNuc;
  std::vector<dpair_t> _threshNuc;
  std::vector<dpair_t> _range;
};
#endif
