#ifndef _FELCHURCHMODEL_H
#define _FELCHURCHMODEL_H

#include "SubModel.h"
#include "MarkovChain.h"
#include <vector>
#include <string>

class FelChurchModel : public SubModel {
 public:
  FelChurchModel(const MarkovChain&, double, double);
  virtual ~FelChurchModel() { }

  double 
  getProb(const std::string&,const std::string&, double) const;

  double 
  getProb(char,char, double) const;


 private:
  double getMutRate() const { return _mRate; }
  double getTnTvRatio() const { return _tnTvRatio; }
  double getAlpha() const {return _alpha; }
  double getBeta() const { return _beta; }
  double getBaseFreq(char) const;
  void init();

 private:
  const MarkovChain& _mc;
  double _tnTvRatio;
  double _mRate;
  double _alpha, _beta;
};

#endif // _FELCHURCHMODEL_H
