#ifndef _GENELIST_H
#define _GENELIST_H

#include "GffFeature.h"
#include <list>
#include <vector>
#include <string>


class GeneList : public std::list<GffFeature*> {
 public:
  GeneList(const std::string& id) : _id(id) { }

  const std::string& getId() const { return _id; }

  bool makeFrame(int,int,char);
  const GffFeature* getOverlap(int) const;
  const GffFeature* getMatchEnd3(int,char) const;
  const GffFeature* getMatchEnd5(int,char) const;
  std::pair<std::string,std::string>
    classType(int,int,char) const;

 private:
    std::string _id;
    std::vector<int> _frame;
};

namespace std {
  ostream& operator<<(ostream&, const GeneList&);
};

#endif // _GENELIST_H
