#include "GffFeature.h"
#include <sstream>
#include <string>
#include <iostream>

using std::list;
using std::ostream;
using std::cout;
using std::endl;
using std::string;
typedef string::size_type size_type;

GffFeature::GffFeature(const GffFeature& gff) : _c1(gff._c1), _c2(gff._c2), _c3(gff._c3), _frame(gff._frame), _end5(gff._end5), _end3(gff._end3),
						_score(gff._score), _c6(gff._c6), _c8(gff._c8) {
}

void
GffFeature::printLstSpecial(std::ostream& os, const list<const GffFeature*>& lst) {
  list<const GffFeature*>::const_iterator iter = lst.begin();
  list<const GffFeature*>::const_iterator stop = lst.end();
  for(; iter != stop; ++iter) {
    const GffFeature& gff = **iter;
    gff.print_debug(os);
    os<<endl;
  }
}

void
GffFeature::printLst(std::ostream& os, const list<GffFeature*>& lst) {
  list<GffFeature*>::const_iterator iter = lst.begin();
  list<GffFeature*>::const_iterator stop = lst.end();
  for(; iter != stop; ++iter) {
    const GffFeature& gff = **iter;
    os<<gff<<endl;
  }
}


void
GffFeature::fillFromBuffer(const string& all) {
  unsigned idx = 0;
  size_type last = 0, cursor = 0;
  //while(cursor != string::npos ) {
  bool stop = false;
  while(!stop) {
    cursor = all.find('\t',last);
    if( cursor == string::npos ) {
      cursor = all.size();
      stop = true;
    }
    string col = all.substr(last,cursor-last);
    //cout<<"col: ["<<col<<"]"<<" idx: "<<idx<<" last: "<<last<<" curr: "<<cursor<<endl;
    if( idx == 0 ) {
      this->_c1 = col;
    } else if( idx == 1 ) {
      this->_c2 = col;
    } else if( idx == 2 ) {
      this->_c3 = col;
    } else if( idx == 3 ) {
      std::istringstream istrm(col.c_str());
      istrm>>this->_end5;
    } else if( idx == 4 ) {
      std::istringstream istrm(col.c_str());
      istrm>>this->_end3;
    } else if( idx == 5 ) {
      //this->_c5 = col; // frame
      if( col[0] == '.' ) this->_frame = -1;
      else {
	std::istringstream istrm(col.c_str());
	istrm>>this->_frame;
      }
    } else if( idx == 6 ) {
      this->_c6 = col; // strand
    } else if( idx == 7 ) {
      if( col[0] == '.' ) this->_score = 0;
      else {
	std::istringstream istrm(col.c_str());
	istrm>>this->_score;
      }
    } else if( idx == 8 ) {
      this->_c8 = col;
    }
    last = cursor+1;
    if( idx > 8 || stop) {
      break;
    }
    ++idx;
  }
  assert(idx==8);
}

ostream&
operator<<(ostream& os, const GffFeature& gff) {
  os<<gff._c1<<'\t'<<gff._c2<<'\t'<<gff._c3<<'\t'<<gff._end5<<'\t';
  os<<gff._end3<<'\t'<<gff._score<<'\t'<<gff._strnd<<'\t'<<gff._frame<<'\t'<<gff._c8;
#if 0
  os<<gff._c3<<" "<<gff.getEnd5()<<" "<<gff.getEnd3();
  if( gff.getFrame() != -1 ) {
    os<<" frame: "<<gff.getFrame();
  }
  os<<" "<<gff.getCol8();
#endif
  return os;
}

void
GffFeature::print_debug(ostream& os) const {
  const GffFeature& gff = *this;
  os<<gff._c3<<" "<<gff.getEnd5()<<" "<<gff.getEnd3();
  if( gff.getFrame() != -1 ) {
    os<<" frame: "<<gff.getFrame();
  }
  os<<" "<<gff.getCol8();
}
