#ifndef _GFFFEATURE_H
#define _GFFFEATURE_H

#include <string>
#include <list>
#include <ostream>

class GffFeature {
 public:
  GffFeature() : _frame(-1) { }
  GffFeature(const GffFeature&);
  void fillFromBuffer(const std::string&);
  int getFrame() const { return _frame; }
  int getEnd5() const { return _end5; }
  int getEnd3() const { return _end3; }
  const std::string& getCol3() const { return _c3; }
  const std::string& getCol8() const { return _c8; }
  
  void adjustEnd5(int off) { _end5 += off; }
  void adjustEnd3(int off) { _end3 += off; }

  void setStrnd(char strnd) { _strnd = strnd; }
  void setFrame(int f) { _frame=f; }
  void setStrId(const std::string& str) { _c1 = str; }
  void setProgName(const std::string& str) { _c2 = str; }
  void setFeatureName(const std::string& str) { _c3 = str; }
  void setEnd5(int val) { _end5 = val; }
  void setEnd3(int val) { _end3 = val; }
  void setScore(double val) { _score = val; }
  void setComment(const std::string& str) { _c8 = str; }

  void print_debug(std::ostream&) const;

  static void
    printLstSpecial(std::ostream&, const std::list<const GffFeature*>&);
  static void
    printLst(std::ostream&,const std::list<GffFeature*>&);

  friend std::ostream& operator<<(std::ostream&, const GffFeature&);

 private:
  std::string _c1, _c2, _c3;
  int _frame,_end5, _end3;
  double _score;
  char _strnd;
  std::string _c6, _c8;
};


#endif // _GFFFEATURE_H
