#ifndef _HISTOGRAM3D_H
#define _HISTOGRAM3D_H

#include "Histogram.h"

class Histogram3d {
 public:
  typedef std::pair<Histogram3d,Histogram3d> pair_t;

 public:
  Histogram3d() { }
  Histogram3d(const Histogram3d&);
  Histogram3d(unsigned,double,double,int,double base=0);

  Histogram3d& operator=(const Histogram3d&);

  void finish();
  void store(unsigned,double);
  void init(unsigned,double,double,int,double base=0);
  double get_prob(unsigned,double) const;
 
  unsigned size() const { return _hist.size(); }
  Histogram3d&
    operator+=(const Histogram3d&);

  Histogram3d&
    operator/=(double);

  friend std::ostream& 
  operator<<(std::ostream&,const Histogram3d&);

 private:
  std::vector<Histogram> _hist;
};

#endif // _HISTOGRAM3D_H
