#ifndef _LABELSEQ_H
#define _LABELSEQ_H

#include "ModelManager.h"
#include "SeqLabelVal.h"
#include "ModelType.h"
#include "InvScoreCache.h"
#include <vector>
#include <list>
#include <string>

class LabelSeq {
 public:
  typedef SeqLabel::ipair_t ipair_t;
  typedef ModelType::inv_t inv_t;
  typedef ModelType::cname_t cname_t;
  typedef std::vector<std::vector<SeqLabelVal> > smatrix_t;
 public:
  LabelSeq(ModelManager& mm) : _mm(mm) { }
  std::list<SeqLabelVal>* 
    label(const std::vector<std::string*>&, int, int,int,int,bool);
  std::list<SeqLabelVal>* 
    labelF(const std::vector<std::string*>&, int, int,int,int,int&,bool,pred_t,const std::vector<int>&, const std::vector<int>&, const std::vector<int>&,bool,bool);

  bool
    hasGcDon(const std::vector<std::string*>&, int, int, const std::list<SeqLabel>&) const; 
  spair_t
    score(const std::vector<std::string*>&, int, int, const std::list<SeqLabel>&) const; 
  spair_t
    scoreF(const std::vector<std::string*>&, int, int, const std::list<SeqLabel>&,int,pred_t) const; 
  void
    debugScoreIntron(int,const std::vector<std::string*>&, int, int, const std::list<SeqLabel>&) const;
  void
    debugScoreSplice(int,const std::vector<std::string*>&, const std::list<SeqLabel>&) const;
  bool
    countConservedMs(int,const std::vector<std::string*>&, const std::list<SeqLabel>&) const;

  static void
    printPcntId(const std::vector<std::string*>&, int start_codon, int stop_codon, const std::list<SeqLabel>& , std::vector<std::vector<int> >&,
		std::vector<std::vector<int> >&, std::list<SeqLabel>&);

 private:
  void
    cacheScore(const InvScoreCache& lbnd, InvScoreCache& rbnd,  const std::vector<std::string*>&, int, int,pred_t) const;
  void add(const SeqLabelVal& sl, const std::vector<std::string*>&, int, int,bool);

  void dpUpdate(const std::vector<InvScoreCache*>&, std::vector<smatrix_t*>&,
		int,int, const std::vector<std::string*>&, int, int,bool,pred_t, 
		const std::vector<int>&, const std::vector<int>&, const  std::vector<int>&,bool,bool);

 private:
  std::list<SeqLabelVal>* traceBack(smatrix_t*,int&);

 private:
  ModelManager& _mm;
  std::list<std::vector<std::vector<SeqLabelVal> >*> _lst;
};

#endif // _LABELSEQ_H

