#ifndef _MODELHASH_T
#define _MODELHASH_T

#include "ModelType.h"
#include "Model.h"
#include "MultiModel.h"
#include <ostream>
#include <ext/hash_map>

struct myhash { 
  size_t operator()(const ModelType::mname_t& __s) const { return __s; }
};

typedef __gnu_cxx::hash_map<ModelType::mname_t,MultiModel*, myhash > MultiModelHashT;
typedef __gnu_cxx::hash_map<ModelType::mname_t,Model*, myhash > ModelHashT;

class ModelHash : public  ModelHashT {
 public:
  Model* 
    compDiff(ModelType::mname_t  m1, ModelType::mname_t m2) const;

  ModelHash& operator=(const ModelHash&);
  void operator+=(const ModelHash&);
  void operator/=(int);
  void print(std::ostream&) const;
  void show_diff(const std::string&) const;
 private:
  Model* cDiff(ModelType::mname_t,ModelType::mname_t) const;

};

#endif // _MODELHASH_T
