#ifndef _MULTIMODEL_H
#define _MULTIMODEL_H

#include "Model.h"
#include "MarkovChain.h"
#include "stype.h"
#include "utils.h"
#include "SubModel.h"
#include "Phylogeny.h"
#include <list>
#include <vector>
#include <string>
#include <iostream>
#include <ext/hash_map>

class MultiModel {
 public:
  typedef __gnu_cxx::hash_map<std::string, MarkovChain*, strhash, eqstr> hashmc_t;

 public:
  MultiModel(Model*,unsigned);
  ~MultiModel();

  inline int getOrder() const { return _order; }
  void update(const  std::vector<std::string*>&,int,int);
  void update1(const  std::vector<std::string*>&,int,int);
  const MarkovChain* getMc(const std::vector<std::string*>&, int, int);

  const SubModel*
    getMc(const std::vector<std::string*>& svec, int pos, int time, Phylogeny::shash_t& mcHash, const std::list<int>& olst, double, double ) const;
  MarkovChain*
    getClosestTarget(const std::vector<std::string*>& svec, int pos, int, int order, const std::list<int>& olst, std::string& addKey) const;

  void read(std::istream&);
  void write(std::ostream&) const;
  void print(std::ostream&) const;

 private:
  void init(Model*);

 private:
  std::vector<Model*> _vec;
  hashmc_t _mcHash;
  int _order;
};
#endif //_MULTIMODEL_H
