#ifndef _OPTIONS_H
#define _OPTIONS_H
//////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2003, The Institute for Genomic Research (TIGR), Rockville,
// Maryland, U.S.A.  All rights reserved.
//////////////////////////////////////////////////////////////////////////////
#include <stdexcept>
#include <ostream>

/**
 * command line interface
 */
struct Options {
  /** allow individual programs (defined by the main)
   ** access private variables to customize program
   ** behavior
   **/
  friend int main(int,char**);
  ~Options();

  /**
   * @param argc - number command line arguments
   * @param argv - command line arguments
   * parameters gotton from c's main function.
   */
  static void createInstance(int argc, char** argv, const std::string& id) {
    _instance = new Options(argc,argv,id);
  }
  static Options* getInstance() {
    return _instance; 
  }
  std::ostream* _logStream;
  bool _quit, _verbose, _oneExon, _useFrame, _useExon;
  std::string _paramFile, _gffFile, _modelFileBase, _header;

protected:
  Options(int argc, char** argv, const std::string&); 

private:
  void parse(int argc, char** argv, const std::string&); 
  static void versionStatement(std::ostream&, const std::string&); 

private:
  static Options* _instance;
};

#endif //_OPTIONS_H
