#include "ParamFile.h"
#include "AnnotationInfo.h"
#include <sstream>
#include <fstream>
#include <stdexcept>

using std::vector;
using std::list;
using std::cout;
using std::endl;
using std::cerr;
using std::string;
using std::ifstream;
using std::istringstream;
typedef std::string::size_type size_type;


ParamFile* ParamFile::_instance = NULL;
void
ParamFile::createInstance(const string& file) {
  if( _instance ) {
    delete _instance;
  }
  _instance = new ParamFile;
  _instance->read(file);
}

void
ParamFile::read(const string& file) {
  ifstream ifs(file.c_str());
  if( !ifs ) {
    string err = string("Error can not open [") + file + string("]");
    throw std::runtime_error(err);
  }
  list<string> lst, lst2;
  string /*key,val1,val2,*/ tName, tseq;
  const int buff_size = 512;
  char buff[buff_size];
  while(ifs.getline(buff,buff_size)) {
    string line(buff);
    const size_type ll = line.find(' ');
    const string key = line.substr(0,ll);
    if( key == "tree" ) {
      tName = line.substr(ll+1,line.size()-ll);
    } else if( key == "targ_seq" ) {
      tseq = line.substr(ll+1,line.size()-ll);
    } else if( key == "annotation_info" ) {
      const string val1 = line.substr(ll+1,line.size()-ll);
      AnnotationInfo::createInstance(val1);
      //_oidx.add(val2);
    } else if( key == "alignment" ) {
      const size_type l2 = line.find(' ',ll+1);
      const string col2 = line.substr(ll+1,l2-ll-1);
      lst.push_back(col2);
      const string col3 = line.substr(l2+1,line.size()-l2);
      lst2.push_back(col3);
      _oidx.add(col3);
      //horrible memory waste, fix
      if( key == "alignment" && col3 == tseq ) {
	_altAlignTarg.read(col2);
      }
    } else if( key == "exon_offset" ) {
      const string col2 = line.substr(ll+1,line.size()-ll);
      istringstream istrm(col2.c_str());
      istrm>>_exonOffset;
    } else if( key == "models" ) {
      //_mfile = val1;
    } else {
      cerr<<"unrecognzied key: "<<key<<endl;
      assert(0);
    }
  }
  _alignedSeq.resize(_oidx.size());
  list<string>::const_iterator aiter2 = lst2.begin();
  list<string>::const_iterator aiter = lst.begin();
  const list<string>::const_iterator astop = lst.end();
  for(; aiter != astop; ++aiter, ++aiter2) {
    string orgName = *aiter2;
    unsigned idx = _oidx.fname2idx(orgName); 
    try 
      {
	_alignedSeq[idx].read(*aiter);
      }
    catch(const std::exception& err) 
      {
	cerr<<err.what()<<endl;
      }
  }
  _phy.read(_oidx,tName);
  if( _oidx.size() > 1 ) {
     _phy.print(cout);
  }
}
