#ifndef _PARAMFILE_H
#define _PARAMFILE_H

#include <string>
#include <vector>
#include "Phylogeny.h"
#include "OrgIdx.h"
#include "seqtype.h"

class ParamFile {
 public:
  
  static void createInstance(const std::string&);
  static ParamFile* getInstance() { return _instance; }

  const fasta& getTarg() const { return _targSeq; }
  fasta& getAltAlignTarg() { return _altAlignTarg; }
  fasta& getConAlignTarg() { return _conAlignTarg; }
  std::vector<fasta>& getAlignedSeq() { return _alignedSeq; }
  const std::vector<fasta>& getAlignedSeq() const { return _alignedSeq; }
  const OrgIdx& getOrgIdx() const { return _oidx; }
  const Phylogeny& getPhylogeny() const { return _phy; }
  const std::string& getModelFile() const { return _mfile; }
  int getExonOffset() const { return _exonOffset; }


 private:
  void read(const std::string&);

 private:
  fasta _altAlignTarg;
  fasta _conAlignTarg;
  fasta _targSeq;
  std::vector<fasta> _alignedSeq;
  OrgIdx _oidx;
  Phylogeny _phy;
  std::string _mfile;
  int _exonOffset;
 private:
  static ParamFile* _instance;
};
#endif // _PARAMFILE_H
