#ifndef _PARSEHEADER_H
#define _PARSEHEADER_H

#include "seqtype.h"
#include "SeqLabel.h"
#include "ExonDescrip.h"
#include "AnnotationInfo.h"
#include "utils.h"
#include <list>
#include <utility>

class ParseHeader {
 public:
  typedef AnnotationInfo::CodeHashT CodeHashT;
  typedef AnnotationInfo::GeneHashT GeneHashT;

 public:
  ParseHeader(const AnnotationInfo* ai) : _ai(ai), _isInitExon(false), _isLastExon(false) { }

  bool parse(const fasta_seq&);
  std::list<int> getExon(const fasta_seq&, const std::vector<int>&, const std::vector<int>&, int, int) const;
  
  std::string getSpliceEvent(const fasta_seq&) const;

  ExonDescrip& getExonDescrip() { return _klst; }
  const ExonDescrip& getExonDescrip() const { return _klst; }
  const std::list<SeqLabel>& getLst() const { return _klst.getSeqLabelLst(); }

  bool getIsInitExon() const { return _isInitExon; }
  bool getIsLastExon() const { return _isLastExon; }

 private:
  void assignAnnotationInfo(const std::string& exns, const AnnotationInfo&);

 private:
  ExonDescrip _klst;
  const AnnotationInfo* _ai;
  bool _isInitExon;
  bool _isLastExon;
};
#endif // _PARSEHEADER_H
