#ifndef _PHYLOMODEL_H
#define _PHYLOMODEL_H

#include "Phylogeny.h"
#include "SubModel.h"

class PhyloModel {
 public:
  PhyloModel(const Phylogeny&, const SubModel&, const Model&, int);

  ~PhyloModel() { }

  double getProb(const std::vector<const std::string*>&,int,int=-1);

  const MarkovChain* getMc(const std::string&,int,int);
  double getCacheVal(const std::vector<const std::string*>&,const std::string&, int,int);
  void updateCache(const std::vector<const std::string*>&,const std::string&, int,int,double);

  static unsigned compKey(const std::string&); 

 private:
  const Phylogen& _phy;
  const SubModel& _mod;
  const Model& _mod;
  std::vector<std::vector<std::vector<double> > > _cache;
};

#endif // _PHYLOMODEL_H
