#ifndef _RATEHMM_H
#define _RATEHMM_H

#include <ostream>
#include <string>
#include <vector>
#include "RateState.h"
#include "RateTrans.h"
#include "ModelType.h"
#include "stype.h"


class RateHmm {
 public:
  typedef ModelType::cname_t cname_t;

 public:
  RateHmm(cname_t cn) : _type(cn) { }
  RateHmm(int,cname_t);
  RateHmm(const RateHmm&);
  ~RateHmm();
  const RateState& getState(int idx) const { return *(_states[idx]); }
  RateState& getState(int idx) { assert(idx < (signed)_states.size()); return *(_states[idx]); }
  std::list<RateTrans*>& getTransLst() { return _trans; }
  void setState(int idx, RateState* rt) { _states[idx] = rt; }
  void print(std::ostream&) const;
  void write(std::ostream&) const;
  void read(std::istream&);
  void normalize(htype_t);
  void normalize1(htype_t);
  void normalize2(htype_t);
  unsigned getNumStates() const { return _states.size(); }
  unsigned getNumLevels() const { return _numLevels; }
  cname_t getType() const { return _type; } 
  HmmComponent* find(const HmmComponent&);

 private:
  std::vector<RateState*> _states;
  std::list<RateTrans*> _trans;
  unsigned _numLevels;
  cname_t _type;
  
};
#endif //_CONSHMM_H
