#ifndef _RATEMANAGER_H
#define _RATEMANAGER_H

#include <ext/hash_map>
#include "Model.h"
#include "RateHmm.h"
#include "SeqLabel.h"
#include "TestModel.h"
#include <iostream>
#include <utility>
#include <ostream>

class RateManager {
 public:
  typedef ModelType::cname_t cname_t;
  struct myhash { size_t operator()(const cname_t& __s) const { 
    return __s; }};

  typedef __gnu_cxx::hash_map<cname_t,RateHmm*, myhash > RateHmmHashT;
  
 public:
  RateManager();
  ~RateManager();
  RateManager(const RateManager&);
  void operator+=(const RateManager&);
  RateManager& operator=(const RateManager&);
  void operator/=(int);

  void print(std::ostream&) const;
  void create();
  void create1();
  bool read(const std::string& file); 
  void write(const std::string& file) const; 
  const RateHmm* getRateHmm(cname_t cn) const;
  RateHmm* getRateHmm(cname_t cn);

  void
    updateRates(const RateManager&);

  void
    updateRates(TestModel&, const RateManager&, TestModel*);

  void
    adjustRates(RateManager& rm, const RateManager& brm, tp2_t&, const int);

  void
    setInitRates();

 private:
  RateHmmHashT _hash;
};
 
#endif // _RATEMANAGER_H
