#ifndef _RATESTATE_H
#define _RATESTATE_H

#include "HmmComponent.h"
#include <ostream>
#include <string>
#include <list>

class RateTrans;

class RateState : public HmmComponent {
 public:
  RateState() : _id(-1) { }
  RateState(int,int,double);
  RateState(const RateState&);
  ~RateState() { }
  
  std::list<RateTrans*>& getOutLst() { return _outLst; }
  const std::list<RateTrans*>& getInLst() const { return _inLst; }
  std::list<RateTrans*>& getInLst() { return _inLst; }

  void transferUpdate(HmmComponent&);
  int getId() const { return _id; }
  int getPhase() const { return _phase; }
  void setProb(double p) { _initProb = p; }
  double getInitProb() const { return _initProb; }
  double getProb() const { return _initProb; }
  double getCnt1() const { return _cnt1; }
  double getCnt() const; // { return _initCnt.empty() ? 0 : _initCnt.front(); }
  double getCntSum() const;
  double getRate() const { return _rate; }
  void setRate(double v) { _rate = v; }
  void update1(double);
  void update(double);
  void print(std::ostream&) const;
  void write(std::ostream&) const;
  void read(std::istream&);
  void reset() { _initCnt.clear(); _cnt1=0; }
  void normalize();
  bool operator==(const HmmComponent&) const;
 private:
  std::list<RateTrans*> _outLst;
  std::list<RateTrans*> _inLst;
  int _id, _phase;
  double _rate;
  double _initProb;
  std::list<double> _initCnt;
  double _cnt1;
};

#endif //_CONSHMM_H
