#ifndef _RATETRANS_H
#define _RATETRANS_H

#include "HmmComponent.h"
#include "utils.h"
#include <ostream>
#include <istream>

class RateState;

class RateTrans : public HmmComponent {
 public:
  RateTrans(RateState&, RateState&);
  RateTrans(RateState&, RateState&,double,double);
  ~RateTrans() { }

  void transferUpdate(HmmComponent& hc);
  int getLeftId() const; 
  int getRghtId() const;

  void update1(double);
  void update(double);
  void setProb(double v) { _prob = v; }
  double getProb() const { return _prob; }
  double getCnt1() const { return _cnt1;}
  double getCnt() const; // { return _cnt.empty() ? 0 :_cnt.front(); }
  double getCntSum() const;
  static void read(std::istream&, ipair_t&, double&, double&);
  void write(std::ostream&) const;
  const RateState& getFr() const { return _from; }
  const RateState& getTo() const { return _to; }
  RateState& getFr() { return _from; }
  RateState& getTo() { return _to; }

  void reset() { _cnt.clear(); _cnt1 = 0;}

  double getRate() const; // { return _to.getRate(); }
  bool operator==(const HmmComponent&) const;

 private:
  RateState& _from;
  RateState& _to;
  double _prob;
  std::list<double> _cnt;
  double _cnt1;
};

#endif // _RATETRANS_H
