#ifndef _RUNMODEL_H
#define _RUNMODEL_H

#include "seqtype.h"
#include "ModelManager.h"
#include "RateManager.h"
#include "TestModel.h"
#include "stype.h"
#include <fstream>

class RunModel {
  typedef SeqLabel::ipair_t ipair_t;

 public:
  RunModel(ModelManager& mm) : _mm(mm) { }
    
  void run(const fasta&);
  std::list<GffFeature*>* run(const fasta&,const std::string&,bool,pred_t,bool,bool,const std::string&);
  void run2(const fasta&,const std::vector<bool>&,bool,pred_t);
  void discTrain1(const fasta&,const std::string&);
  void discTrain(const fasta&,const std::string&);
  void paramSearch(const fasta&, const std::string&) ;
  TestModel* paramSearch1(const fasta&, const std::string&,RateManager*,RateManager&,TestModel* = NULL) ;
  void adjustTrans(const fasta&, const std::string&) ;
  std::list<GffFeature*>*
    collectExons(const std::vector<std::string*>&, const std::list<SeqLabelVal>&, const int, int, int, pred_t, const std::string&, const std::string&, const ExonDescrip&) ;
  static void countPcntId1(const fasta&, const std::string&,std::vector<int>&,std::vector<int>&);
  static void countPcntId(const fasta&, std::vector<std::vector<int> >&, std::vector<std::vector<int> >&, const std::string&);
  void
    debugScoreIntron(const fasta&,int);

 private:
  ModelManager& _mm;
};
#endif // _RUNMODEL_H

