#include "SeqLabelVal.h"
#include <iostream>
#include <iomanip>

using std::list;
using std::vector;
using std::cout;
using std::endl;

std::ostream&
operator<<(std::ostream& os, const SeqLabelVal& sl) {
  os<<(const SeqLabel&)sl<<" "<<std::setprecision(5)<<sl.getVal();
  return os;
}

void
SeqLabelVal::printLst(std::ostream& os, const list<SeqLabelVal>& lst) {
  list<SeqLabelVal>::const_iterator iter = lst.begin();
  list<SeqLabelVal>::const_iterator stop = lst.end();

  for(; iter != stop; ++iter) {
    const SeqLabelVal& sl = *iter;
    os<<sl<<endl;
  }
}

vector<vector<SeqLabelVal> >*
SeqLabelVal::splitLabel1() const {
  vector<vector<SeqLabelVal> >* vecp = NULL;
  if(getLabel()==eDon) {
    const int size = 9;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(unsigned i = 0; i < 3; ++i) {
      vec[0][i].setLabel(eNed);
      vec[0][i].setEvent(eCon);
      vec[1][i].setLabel(eCed);
      vec[1][i].setEvent(eAlt);
      vec[2][i].setLabel(eIrSd);
      vec[2][i].setEvent(eAlt);
      vec[3][i].setLabel(eIrAfmd);
      vec[3][i].setEvent(eAlt);
      vec[4][i].setLabel(eIrFmd1);
      vec[4][i].setEvent(eAlt);
      vec[7][i].setLabel(eIrFmd2);
      vec[7][i].setEvent(eAlt);
      vec[5][i].setLabel(eFmd1);
      vec[5][i].setEvent(eAlt);
      vec[8][i].setLabel(eFmd2);
      vec[8][i].setEvent(eAlt);
      vec[6][i].setLabel(eAfmd);
      vec[6][i].setEvent(eAlt);
    }
  }
  else if(getLabel()==eAcc) {
    const int size = 9;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(unsigned i = 0; i < 3; ++i) {
      vec[0][i].setLabel(eNea);
      vec[0][i].setEvent(eCon);
      vec[1][i].setLabel(eCea);
      vec[1][i].setEvent(eAlt);
      vec[2][i].setLabel(eIrSa);
      vec[2][i].setEvent(eAlt);
      vec[3][i].setLabel(eIrAfma);
      vec[3][i].setEvent(eAlt);
      vec[4][i].setLabel(eIrFma1);
      vec[4][i].setEvent(eAlt);
      vec[7][i].setLabel(eIrFma2);
      vec[7][i].setEvent(eAlt);
      vec[5][i].setLabel(eFma1);
      vec[8][i].setEvent(eAlt);
      vec[8][i].setLabel(eFma2);
      vec[5][i].setEvent(eAlt);
      vec[6][i].setLabel(eAfma);
      vec[6][i].setEvent(eAlt);
    }
  } else if(getLabel()==eEnd) {
    int size = 4;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(signed i = 0; i < 3; ++i) {
      vec[0][i].setLabel(eEnd);
      vec[0][i].setEvent(eCon);
      vec[1][i].setLabel(eEnd);
      vec[1][i].setEvent(eAlt);
      vec[2][i].setLabel(eEnd1);
      vec[2][i].setEvent(eCon);
      vec[3][i].setLabel(eEnd1);
      vec[3][i].setEvent(eAlt);
    }
  } else {
    int size = 2;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(signed i = 0; i < 3; ++i) {
      vec[0][i].setLabel(getLabel());
      vec[0][i].setEvent(eCon);
      vec[1][i].setLabel(getLabel());
      vec[1][i].setEvent(eAlt);
    }
  }
  return vecp;
}

vector<vector<SeqLabelVal> >*
SeqLabelVal::splitLabelCons2() const {
  vector<vector<SeqLabelVal> >* vecp = NULL;
  if(getLabel()==eDon) {
    const int size = 2;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(unsigned i = 0; i < 3; ++i) {
      vec[0][i].setLabel(eNed);
      vec[0][i].setEvent(eCon);

      vec[1][i].setLabel(eCed);
      vec[1][i].setEvent(eAlt);
    }
  }
  else if(getLabel()==eAcc) {
    const int size = 2;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(unsigned i = 0; i < 3; ++i) {
      vec[0][i].setLabel(eNea);
      vec[0][i].setEvent(eCon);

      vec[1][i].setLabel(eCea);
      vec[1][i].setEvent(eAlt);
    }
  }
  else if(getLabel()==eEnd) {
    int size = 4;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(signed i = 0; i < 3; ++i) {
      vec[0][i].setLabel(eEnd);
      vec[0][i].setEvent(eCon);
      vec[1][i].setLabel(eEnd);
      vec[1][i].setEvent(eAlt);
      vec[2][i].setLabel(eEnd1);
      vec[2][i].setEvent(eCon);
      vec[3][i].setLabel(eEnd1);
      vec[3][i].setEvent(eAlt);
    }
  } else {
    int size = 2;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(signed i = 0; i < 3; ++i) {
      vec[0][i].setLabel(getLabel());
      vec[0][i].setEvent(eCon);
      vec[1][i].setLabel(getLabel());
      vec[1][i].setEvent(eAlt);
    }
  }
  return vecp;
}


vector<vector<SeqLabelVal> >*
SeqLabelVal::splitLabelCons1() const {
  vector<vector<SeqLabelVal> >* vecp = NULL;
  if(getLabel()==eDon) {
    const int size = 1;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(unsigned i = 0; i < 3; ++i) {
      vec[0][i].setLabel(eNed);
      vec[0][i].setEvent(eCon);
    }
  }
  else if(getLabel()==eAcc) {
    const int size = 1;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(unsigned i = 0; i < 3; ++i) {
      vec[0][i].setLabel(eNea);
      vec[0][i].setEvent(eCon);
    }
  }
  else if(getLabel()==eEnd) {
    int size = 2;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(signed i = 0; i < 3; ++i) {
      vec[0][i].setLabel(eEnd);
      vec[0][i].setEvent(eCon);
      vec[1][i].setLabel(eEnd1);
      vec[1][i].setEvent(eCon);
    }
  } else {
    int size = 1;
    vecp = new vector<vector<SeqLabelVal> >(size);
    vector<vector<SeqLabelVal> >& vec = *vecp;
    for(signed i = 0; i < size; ++i) {
      vec[i].resize(3,*this);
    }
    for(signed i = 0; i < 3; ++i) {
      vec[0][i].setLabel(getLabel());
      vec[0][i].setEvent(eCon);
    }
  }
  return vecp;
}
