#ifndef _SEQLABELVAL_H
#define _SEQLABELVAL_H

#include "SeqLabel.h"
#include "stype.h"
#include <list>
#include <vector>

class SeqLabelVal : public SeqLabel {
 public:
  SeqLabelVal(blabel_t bl, event_t ev, int f,int t, spair_t v) : SeqLabel(bl,ev,f,t), _val(v), _prev(NULL), _isNew(true) { }
  SeqLabelVal(const SeqLabel& sl, spair_t v) : SeqLabel(sl), _val(v), _prev(NULL), _isNew(true) { }
		      SeqLabelVal(const SeqLabelVal& slv) : SeqLabel(slv), _val(slv._val), _prev(slv._prev), _isNew(slv._isNew) { }
	
  bool isNew() const { return _isNew; }
  std::vector<std::vector<SeqLabelVal> >* splitLabel1() const;
  std::vector<std::vector<SeqLabelVal> >* splitLabelCons2() const;
  std::vector<std::vector<SeqLabelVal> >* splitLabelCons1() const;
  std::list<std::vector<SeqLabelVal> >* splitLabel() const;
  std::list<std::vector<SeqLabelVal> >* splitLabelCons() const;
  bool isValid() const { return _val.first; }
  double getVal() const { return _val.second; }
  const SeqLabelVal* getPrev() const { return _prev; }
  static void
    printLst(std::ostream&, const std::list<SeqLabelVal>&);
  void setVal(spair_t v) { _val = v; _isNew=false; }
  void setPred(const SeqLabelVal* p) { _prev = p; }

 private:
  spair_t _val;
  const SeqLabelVal* _prev;
  bool _isNew;
};

std::ostream&
operator<<(std::ostream&,const SeqLabelVal&);
#endif // _SEQLABELVAL_H
