#ifndef _TAMURANEI_H
#define _TAMURANEI_H

#include "SubModel.h"
#include "MarkovChain.h"
#include "cidx.h"
#include "base.h"
#include <cmath>
#include <vector>
#include <string>

class TamuraNei : public SubModel {
 public:
  TamuraNei(const MarkovChain&, double, double);
  virtual ~TamuraNei() { }

  inline double 
  getProb(const std::string&,const std::string&, double) const;

  inline double 
  getProb(char,char, double) const;

  void print(std::ostream&) const;

 private:
  double getTnTvRatio() const { return _tnTvRatio; }
  double getBeta() const { return _beta; }
  double getBaseFreq(char) const;
  void init();

 private:
  double _tnTvRatio;
  double _alphay, _alphar, _beta;
  std::vector<double> _counts;
};

#include "TamuraNei.hpp" //inlines

#endif // _TAMURANEI_H
