#include "Trellis.h"
#include "utils.h"
#include <iostream>
#include <vector>

using std::pair;
using std::list;
using std::vector;
using std::cerr;
using std::endl;

int 
Trellis::getSize(htype_t ht) {
  const int ts = getLevels(ht);
  const int tm = getTimes(ht);
  return ts*tm;
}

int 
Trellis::getTimes(htype_t ht) {
  switch(ht) {
  case eNpc: return 1;
  case ePrc1: return 3;
  case ePrc2: return 3;
  case eDon: return 1;
  case eAcc: return 1;
    //case eDon: return 9;
      //case eAcc: return 24;
  default: 
    cerr<<"hmmmfder\n";
    assert(0);
    return -1;
  }
}

static const int cNUM_RATES = 9;
int 
Trellis::getLevels(htype_t ht) {
  switch(ht) {
  case eNpc: return cNUM_RATES;
  case ePrc1: return cNUM_RATES;
  case ePrc2: return cNUM_RATES;
  case eDon: return cNUM_RATES;
  case eAcc: return cNUM_RATES;
  default: 
    cerr<<"hmmmfder\n";
    assert(0);
    return -1;
  }
}
//double Trellis::getFalseTransProb() { return (double)1/(double)cNUM_RATES; }
//double Trellis::getFalseInitProb() { return  (double)1/(double)cNUM_RATES; }

#if 0
static double npcInit[] = {
  0.05,0.05,0.05, 0.05, 0.25, 0.35, 0.197, 0.001, 0.001, 0.001
};

static double npcRate[] = {
  1.0,1.1,1.2, 1.4, 1.5, 1.6, 1.8, 1.9, 2.0
};
static double prcInit1[] = {
  0.1, 0.25, 0.35, 0.20, 0.05, 0.096, 0.001, 0.001, 0.001, 0.001
};
static double prcInit2[] = {
  0.1, 0.25, 0.35, 0.20, 0.05, 0.096, 0.001, 0.001, 0.001, 0.001
};

static double prcRate12[] = {
  0.5,0.6,0.7, 0.9, 1.0, 1.1, 1.3, 1.5, 1.7
};
static double prcInit3[] = {
  0.051,0.051,0.101, 0.15, 0.20, 0.20, 0.10, 0.1, 0.096, 0.001
};
static double prcRate3[] = {
  0.5,0.7,0.9, 1.2, 1.4, 1.6, 1.8, 1.9, 2.1
};

static double donInit[] = {
  0.001,0.20, 0.25, 0.35, 0.05, 0.10, 0.096, 0.001, 0.001, 0.001
};
static double donRate[] = {
  0.7,0.8,0.9, 1.1, 1.2, 1.3, 1.5, 1.6, 1.7
};

static double accInit[] = {
  0.001,0.001, 0.25, 0.35, 0.20, 0.10, 0.05, 0.096, 0.001, 0.001
};

static double accRate[] = {
  0.7,0.9,1.0, 1.2, 1.3, 1.4, 1.6, 1.7, 1.8
};
#endif

#if 0
static double getInit(htype_t ht, int idx, int time) {
  return 1.0/(double)cNUM_RATES;
  switch(ht) {
  case eNpc:
    return npcInit[idx];
  case ePrc1:
  case ePrc2:
    if( time == 0 ) {
      return prcInit1[idx];
    } else if( time ==1 ) {
      return prcInit2[idx];
    } else if( time ==2 ) {
      return prcInit3[idx];
    } else {
      assert(0);
    }
  case eDon:
    return donInit[idx];
  case eAcc:
    return accInit[idx];
  default:
    assert(0);
  }
}
#endif

#if 0
static double getRate(htype_t ht, int idx, int time) {
  switch(ht) {
  case eNpc:
    return npcRate[idx];
  case ePrc1:
  case ePrc2:
    if( time == 0 || time == 1 ) {
      return prcRate12[idx];
    } else if( time ==2 ) {
      return prcRate3[idx];
    } else {
      assert(0);
    }
  case eDon:
    return donRate[idx];
  case eAcc:
    return accRate[idx];
  default:
    assert(0);
  }
}
#endif

RateHmm*
Trellis::buildHmm(htype_t ht, ModelType::cname_t cn) {
#if 0
  const unsigned times = getTimes(ht);
  const unsigned num_levels = getLevels(ht);
  const unsigned num_states = times*num_levels;
  RateHmm* retHmm = new RateHmm(num_states,cn);
  for(unsigned time = 0; time < times; ++time) {
    const unsigned timeIdx = time >= times ? times-1 : time;
    for(unsigned i = 0; i < num_levels; ++i) {
      int idx = (times*i)+timeIdx;
      const double rate = getRate(ht,i,time);
      RateState* retState = new RateState(idx,time,rate);
      const double sprob = getInit(ht,i,time);
      retState->setProb(sprob);
      retHmm->setState(idx,retState);
    }
  }
  unsigned tidx = 0;
  for(unsigned time = 0; time < times; ++time) {
    const unsigned timeIdx = time >= times ? times-1 : time;
    for(unsigned i = 0; i < num_levels; ++i) {
      int idx = (times*i)+timeIdx;
      RateState& fr = retHmm->getState(idx);
      for(unsigned j= 0; j < num_levels; ++j) {
	int ntime=-1;
	if(times==1) {
	  ntime=time;
	} else {
	  ntime=(time+1>=times)?0:time+1;
	}
	const unsigned ntimeIdx = ntime >= (signed)times ? (signed)times-1 : ntime;
	int jdx = (times*j)+ntimeIdx;
	RateState& to = retHmm->getState(jdx);
	const bool b1 = (i==j);
	const bool b2 = ((abs(i-j)%3) ==0 );
	if( b1 || b2 ) { 
	  RateTrans* trans = new RateTrans(fr,to);
	  fr.getOutLst().push_back(trans);
	  to.getInLst().push_back(trans);
	  retHmm->getTransLst().push_back(trans);
	  ++tidx;
	} 
      }
    }    
  }
  for(unsigned si = 0; si < retHmm->getNumStates(); ++si) {
    RateState& rs = retHmm->getState(si);
    assert(!rs.getOutLst().empty());
    assert(!rs.getInLst().empty());
    list<RateTrans*>::iterator iter = rs.getOutLst().begin();
    const list<RateTrans*>::iterator stop = rs.getOutLst().end();
    const unsigned nt = rs.getOutLst().size();
    const double prob = 1.0/(double)nt;
    for(; iter != stop; ++iter) {
      RateTrans* trans = *iter;
      trans->setProb(prob);
    }
  }
  retHmm->write(cout);
#endif
	assert(0);
  return NULL;
}

Trellis::Trellis(RateHmm* hmm) {
  _hmm.push_back(hmm);
}

Trellis::~Trellis() {
  assert(_states.size()==_prev.size());
  assert(_states.size()==_currs.size());
  list<vector<spair_t>*>::iterator si = _states.begin();
  list<vector<spair_t>*>::iterator ci = _currs.begin();
  list<vector<RateTrans*>*>::iterator pi = _prev.begin();
  const list<vector<spair_t>*>::iterator ss = _states.end();
  for(; si != ss; ++si, ++ci, ++pi) {
    delete *si;
    delete *ci;
    delete *pi;
  }
}


spair_t
Trellis::getBestScore(htype_t ht, int phase) const {
  unsigned size = Trellis::getLevels(ht);
  spair_t bs(false,0);
  const unsigned times = getTimes(ht);
  assert(times>=1);
  const vector<spair_t>& states = *(_states.back());
  const int phaseIdx = phase >= (signed)times ? (signed)times-1 : phase;
  for(unsigned iter = 0; iter < size; ++iter) {
    const int idx = (times*iter)+phaseIdx;
    assert(idx < (signed)states.size());
    const spair_t cs = states[idx]; 
    if(cs.first && (cs.second > bs.second || !bs.first) ) {
      bs = cs;
    }
  }
  return bs;
}
  //const list<vector<RateTrans*>*>::reverse_iterator ts = _prev.rend();
  //const list<int>::reverse_iterator ps = _phase.rend();
  //const list<vector<spair_t>*>::reverse_iterator ss = _states.rend();
vector<ParamSearchPos>*
Trellis::getPath(htype_t ht, int phase) {
  vector<ParamSearchPos>* result = new vector<ParamSearchPos>(_states.size());
  vector<ParamSearchPos>& resultRef = *result;
  int cidx = -1;
  
  list<int>::reverse_iterator pi = _phase.rbegin();
  list<vector<spair_t>*>::reverse_iterator si = _states.rbegin();
  list<RateHmm*>::reverse_iterator ri = _hmm.rbegin();
  const list<RateHmm*>::reverse_iterator rs = _hmm.rend();
  list<vector<RateTrans*>*>::reverse_iterator ti = _prev.rbegin();
  for(int cnt = result->size()-1; cnt >= 0; --cnt, ++ti, ++ri, ++si, ++pi) {
    assert(ri != rs);
    const vector<RateTrans*>& trans = **ti;
    RateHmm* hmm = *ri;
    assert(hmm);
    const int cphase = *pi;
    if( cidx == -1 ) {
      ModelType::cname_t tcn = (*ri)->getType();
      spair_t bs(false,0);
      const vector<spair_t>& states = **si;
      const htype_t lht = cname2htype(tcn,false);
      const unsigned levels = Trellis::getLevels(lht);
      const unsigned times = getTimes(lht);
      const int phaseIdx = cphase >= (signed)times ? (signed)times-1 : cphase;
      for(unsigned iter = 0; iter < levels; ++iter) {
	const int idx = (times*iter)+phaseIdx;
	assert(idx < (signed)states.size());
	const spair_t cs = states[idx]; 
	if(cs.first && (cs.second > bs.second || !bs.first) ) {
	  bs = cs;
	  cidx = idx;
	}
      }
      cout<<"What the f: "<<bs<<endl;
    }
    //const spair_t score = (**si)[cidx];
    if(trans[cidx]) {
      assert( cidx < (signed)trans.size());
      assert(cidx != -1);
      RateTrans* currTrans = trans[cidx];
      resultRef[cnt] = ParamSearchPos(currTrans,hmm,cnt+4,cphase);
      cidx = currTrans->getFr().getId();
    } else {
      RateState& rsRef = hmm->getState(cidx);
      resultRef[cnt] = ParamSearchPos(&rsRef,hmm,cnt+4,cphase);
      cidx = -1;
    }
    assert(resultRef[cnt].getComp());
    //ModelType::cname_t cn = hmm->getType();
    //cout<<"assign: "<<cnt+4<<" "<<ModelType::cname2str(cn)<<" "<<score<<" = ";
    //resultRef[cnt].first->write(cout);
  }
  return result;
}

HmmComponent*
Trellis::getBestScore1(htype_t ht, int phase, spair_t& ss, bool isInit) const {
  unsigned size = Trellis::getLevels(ht);
  spair_t bs = spair_t(false,0);
  ss = spair_t(false,0);
  if( _states.empty() ) {
    return NULL;
  }
  const unsigned times = getTimes(ht);
  assert(times>=1);
  RateHmm* hmm = _hmm.back();
  const vector<spair_t>& states = *(_states.back());
  const vector<spair_t>& currs = *(_currs.back());
  RateState* bstate = NULL;
  const int phaseIdx = phase >= (signed)times ? (signed)times-1 : phase;
  for(unsigned iter = 0; iter < size; ++iter) {
    const int idx = (times*iter)+phaseIdx;
    assert(idx < (signed)states.size());
    const spair_t cs = states[idx]; 
    const spair_t save = currs[idx]; 
    if(cs.first && (cs.second > bs.second || !bs.first) ) {
      bs = cs;
      ss = save;
      bstate = &(hmm->getState(idx));
    }
  }
  HmmComponent* hc = NULL;
  if( isInit ) {
    hc = bstate;
  } else if(bstate) {
    list<RateTrans*>::iterator iter = bstate->getInLst().begin();
    const list<RateTrans*>::iterator stop = bstate->getInLst().end();
    RateTrans* trans = NULL;
    for(; iter != stop; ++iter) {
      RateTrans* tmp = *iter;
      if( !trans ) trans = tmp;
      else if( trans->getProb() < tmp->getProb() ) {
	trans = tmp;
      }
    }
    hc = trans;
  }
  return hc;
}

void
Trellis::print(std::ostream& os) const {
  const vector<spair_t>& states = *(_states.back());
  for(unsigned i = 0; i < _states.size(); ++i) {
    os<<i<<" "<<states[i]<<endl;
  }
}

int
Trellis::getPrevTime(htype_t ht, int ctime) {
  int numTimes=getTimes(ht);
  int ptime = ctime-1;
  if( ptime < 0 )
    ptime = numTimes-1;
  return ptime;
}

RateState&
Trellis::getState(int idx) { 
  RateHmm* hmm = _hmm.back();
  return hmm->getState(idx);
}

spair_t
Trellis::getScorePrev(const RateState& cs) const { 
  list<vector<spair_t>*>::const_reverse_iterator iter = _states.rbegin();
  const list<vector<spair_t>*>::const_reverse_iterator stop = _states.rend();
  ++iter;
  assert(iter != stop);
  vector<spair_t>& states = **iter;
  const int idx = cs.getId();
  assert(idx >=0 && idx <= (signed)states.size());
  return states[idx]; 
}

spair_t
Trellis::getScoreCurr(const RateState& cs) const { 
  const vector<spair_t>& states = *(_states.back());
  const int idx = cs.getId();
  assert(idx >=0 && idx <= (signed)states.size());
  return states[idx]; 
}

void
Trellis::add(bool isInit, htype_t last_ht, int curr_phase, RateHmm* hmm) {
  spair_t initVal(false,0);
  if( isInit && _states.size() > 0 ) {
    const int pphase = _phase.back();
    initVal = getBestScore(last_ht,pphase);
  }
  const unsigned size = hmm->getNumStates();
  vector<spair_t>* states = new vector<spair_t>(size,initVal);
  vector<spair_t>* currs = new vector<spair_t>(size,initVal);
  vector<RateTrans*>* pred = new vector<RateTrans*>(size,NULL);
  _states.push_back(states);
  _currs.push_back(currs);
  _prev.push_back(pred);
  _hmm.push_back(hmm);
  _phase.push_back(curr_phase);
}

void
Trellis::set(const RateState& cs, const spair_t& sumScore, RateTrans* trans, const spair_t& optionalCurrScore) {  
  vector<spair_t>& states = *(_states.back());
  vector<spair_t>& currs = *(_currs.back());
  vector<RateTrans*>& prev = *(_prev.back());
  const int idx = cs.getId();
  assert(idx >=0 && idx <= (signed)states.size());
  states[idx] = sumScore; 
  currs[idx] = optionalCurrScore;
  prev[idx] = trans;
}

#if 0
void 
Trellis::set(const RateState& cs, const spair_t& v, const spair_t& c) { 
  const int idx = cs.getId();
  assert(idx >=0 && idx <= (signed)_states.size());
  _states[idx] = v; 
  _currs[idx] = c;
}
#endif

#if 1
htype_t
Trellis::cname2htype(ModelType::cname_t cn, bool allowMute) {
  switch(cn) {
  case ModelType::eCintronDn:
  case ModelType::eAintronDn:
  case ModelType::eCintronUp:
  case ModelType::eAintronUp:
  case ModelType::eAexonNpc:
  case ModelType::eCexonNpc:
    return eNpc;
  case ModelType::eAdon:
  case ModelType::eCdon:
    return eDon;
  case ModelType::eAacc:
  case ModelType::eCacc:
    return eAcc;
  case ModelType::eAexonPrc:
  case ModelType::eCexonPrc:
    return allowMute?ePrc2:ePrc1;
  default:
    cerr<<"error here dfa\n";
    return eEmptyState;
  }
}

htype_t
Trellis::mname2htype(ModelType::mname_t mn, bool allowMute) {
  switch(mn) {
  case ModelType::eCintronNonConDn:
  case ModelType::eCintronConDn:
  case ModelType::eAintronNonConDn:
  case ModelType::eAintronConDn:
  case ModelType::eCintronNonConUp:
  case ModelType::eCintronConUp:
  case ModelType::eAintronNonConUp:
  case ModelType::eAintronConUp:
  case ModelType::eCexonNonConNpc:
  case ModelType::eCexonConNpc:
  case ModelType::eAexonNonConNpc:
  case ModelType::eAexonConNpc:
    return eNpc;
  case ModelType::eCexonNonConPrc:
  case ModelType::eCexonConPrc:
  case ModelType::eAexonNonConPrc:
  case ModelType::eAexonConPrc:
    return allowMute ? ePrc2 : ePrc1;
  case ModelType::eCdonCon:
  case ModelType::eAdonCon:
  case ModelType::eDonNonc:
    return eDon;
  case ModelType::eCaccCon:
  case ModelType::eAaccCon:
  case ModelType::eAccNonc:
    return eAcc;
  default:
    return eEmptyState;
  }
}


Trellis::hpair_t
Trellis::extract_htype(const vector<string*>& svec, int pos, cname_t cn, int phase) {
  phase = phase==-1?0:phase;
  htype_t ht  = Trellis::cname2htype(cn,false);
  const bool isPrcExon = ModelType::isPrcExon(cn);
  bool isConsCodon = true;
  if(isPrcExon) {
    // only preclude the use of stop codons in target sequence
    int off =  -1;
    if( phase==0 ) {
      off=1;
    } else if( phase == 1 ) {
      off=2;
    } else if( phase == 2 ) {
      off=3;
    }
    const int codonSize = 3;
    if( pos-off >= 0 && ((pos-off)+codonSize < (signed)svec[0]->size()) ) {
      assert( (pos-off) >= 0 && ((pos-off)+codonSize < (signed)svec[0]->size()));
      string codon = svec[0]->substr(pos-off,codonSize);
      makelower(codon);
      if(phase == 2) {
	if(codon=="taa" || codon=="tga"||codon=="tag") {
	  //if(verbose) {
	    //cout<<"pos: "<<pos<<" phase: "<<phase<<" STOP CODON"<<endl;
	  //}
	  return hpair_t(eEmptyState,-1);
	}
      }
      const char targAA = codon[0]!='-'&&codon[1]!='-'&&codon[2]!='-' ? codon2aa(codon) : 'B';
      for(unsigned k = 1; k < svec.size(); ++k) {
	if(svec[k]) {
	  const string& tstr = *svec[k];
	  assert( (pos-off) >= 0 && ((pos-off)+codonSize < (signed)svec[k]->size()));
	  string icodon = tstr.substr(pos-off,codonSize);
	  makelower(icodon);
	  const char infAA = icodon[0]!='-'&&icodon[1]!='-'&&icodon[2]!='-' ? codon2aa(icodon) : 'B';
	  if( targAA != infAA ) {
	    isConsCodon = false;
	    break;
	  }
	}
      }
    }
  }
  // use conserved model only
  const int prev = 3;
  bool isConsCol = isCons(pos,svec,prev);
  int clevel = 0;
  if( isPrcExon && isConsCodon && !isConsCol ) {
    clevel = 3; // tolerate synonymous substitutions
    ht  = Trellis::cname2htype(cn,true);
  } else if( isPrcExon || ModelType::isSplice(cn) ) {
    // otherwise more strict for codons and splice sites
    clevel = 0;
  } else if( isConsCol ) {
    // otherwise if conserved column, use slow mutation model
    clevel = 0;
  } else {
    // otherwise if not conserved use fast mutation model
    clevel = 3;
  }
  return hpair_t(ht,clevel);
}
#endif
