#include "ParamFile.h"
#include "ModelManager.h"
#include "utils.h"
#include "Options.h"
#include "AnnotationInfo.h"
#include "seqtype.h"
#include "stype.h"
#include "RunModel.h"
#include <utility>
#include <stdexcept>
#include <sstream>
#include <iostream>
#include <list>
#include <fstream>
#include <time.h>
#include <vector>
#include <string>
#include <sys/types.h> 
#include <unistd.h>
#include <iomanip>
#include <sstream>

using std::ostringstream;
using std::string;
using std::cerr;
using std::cout;
using std::endl;
using std::list;
using std::ifstream;
using std::ofstream;
using std::vector;

AnnotationInfo* AnnotationInfo::_instance = NULL;

static void 
tprn() {
  for(unsigned i =0; i < StateTrans::eStateSize; ++i) {
    cout<<"init["<<StateTrans::state2str((StateTrans::state_t)i)<<"]=1"<<endl;
  }
  for(unsigned i =0; i < StateTrans::eStateSize; ++i) {
    for(unsigned j =0; j < StateTrans::eStateSize; ++j) {
      cout<<"trans["<<StateTrans::state2str((StateTrans::state_t)i)<<"]["<<StateTrans::state2str((StateTrans::state_t)j)<<"]=1"<<endl;
    }
  }
}

int 
main(int argc, char** argv) {
  int status = 0;
  const string cvs_tag = "1.0.0";
  string id = string(argv[0]) + string("-") + cvs_tag;
  try 
    {
      string cid = id + string(": prediction of alternatively spliced exons");
      Options::createInstance(argc,argv,cid);
      const Options& options = *(Options::getInstance());
      if( options._quit ) {
	usage(argv[0]);
	return 0;
      }
      time_t tm = time(NULL);
      srand(tm);
      srand48(tm);  // stl uses lrand48 (when available)

      const string& pfile = options._paramFile;
      const string& file = options._modelFileBase;
      cout<<"Reading param file: "<<pfile<<endl;
      ParamFile::createInstance(pfile);

      ParamFile* pf = ParamFile::getInstance();
      const OrgIdx oidx = pf->getOrgIdx();

      ModelManager mm;
      cout<<"Reading model file: "<<file<<endl;
      if( mm.read(file) ) {
	mm.getStateTrans().drawGraphViz();
      } else {
         cerr<<"Unable to read models in: ["<<file<<"]"<<endl;
      }
    }
  catch(std::exception& err)
    {
      cerr<<err.what()<<endl;
      status=1;
    }
  catch(...) 
    {
      cerr<<"Unhandled exception, Problems"<<endl;
      status=1;
    }
  if( status )
    usage(argv[0]);
  return status;
}
