namespace bioinfo
{
  template<size_t NB>
  std::size_t
  bio_bit_traits<NB>::bit_code(basic_char_type c) {
    switch(c) {
    case 'a':
    case 'A':
      return 0x0;
    case 'c':
    case 'C':
      return 0x1;
    case 'g':
    case 'G':
      return 0x2;
    case 't':
    case 'T':
      return 0x3;
    default:
      return 0x0;
    }
  }
  template<size_t NB>
  typename bio_bit_traits<NB>::basic_char_type
  bio_bit_traits<NB>::char_code(typename bio_bit_traits<NB>::char_type ch) {
    typename bio_bit_traits<NB>::char_type high_order_mask = 0x3;
    ch = high_order_mask & ch; // ignore higher order bits
    if( ch == 0x0 ) 
      return 'a';
    else if( ch == 0x1)
      return 'c';
    else if( ch == 0x2)
      return 'g';
    else if( ch == 0x3)
      return 't';
    else 
      return 'e';
  }
  template<size_t NB>
  bool
  bio_bit_traits<NB>::valid_code(basic_char_type c) {
    switch(c) {
    case 'a':
    case 'A':
    case 'c':
    case 'C':
    case 'g':
    case 'G':
    case 't':
    case 'T':
      return true;
    default:
      return false;
    }
  }
}
