namespace bioinfo 
{
  char idx2c(unsigned ch) {
    switch(ch) {
    case 0:
      return 'a';
    case 1:
      return 'c';
    case 2:
      return 'g';
    case 3:
      return 't';
    default:
      assert(0);
      return -1;
    }
  }

  int c2idx(char ch) {
    switch(ch) {
    case 'A':
    case 'a':
      return 0;
    case 'C':
    case 'c':
      return 1;
    case 'G':
    case 'g':
      return 2;
    case 'T':
    case 't':
      return 3;
    default:
      assert(0);
      return -1;
    }
  }
  int c2idx(char ch, char def) {
    switch(ch) {
    case 'A':
    case 'a':
      return 0;
    case 'C':
    case 'c':
      return 1;
    case 'G':
    case 'g':
      return 2;
    case 'T':
    case 't':
      return 3;
    default:
      return c2idx(def);
    }
  }
  int di2idx(char a, char b, char def[2]) {
    int idx1 = bioinfo::c2idx(a);
    int idx2 = bioinfo::c2idx(b);
    int val = -1;
    if( idx1 != -1 && idx2 != -1 ) {
      val = (idx2*4)+idx1;
    } else {
      idx1 = bioinfo::c2idx(def[0] );
      idx2 = bioinfo::c2idx(def[1] );
      val = (idx2*4)+idx1;
    }
    return val;
  }
  int di2idx(char a, char b) {
    int idx1 = bioinfo::c2idx(a);
    int idx2 = bioinfo::c2idx(b);
    int val = -1;
    if( idx1 != -1 && idx2 != -1 ) {
      val = (idx2*4)+idx1;
    }
    return val;
  }
  
  int c2BaseTypeIdx(char ch) {
    switch(ch) {
    case 'A':
    case 'a':
    case 'G':
    case 'g':
      return 0;
    case 'C':
    case 'c':
    case 'T':
    case 't':
      return 1;
    default:
      return -1;
    }
  }

};
